;*************************************************************************
; Ramdom Hex Viewer v4.0
;  by Jim Reardon
;
;       F1 - Jump To Address
;       F2 - Convert Hex to Decimal (Will be a menu soon)
;         *F1 - Hex -> Decimal
;         *F2 - Decimal -> Hex
;         *F3 - Character -> Hex
;         *F4 - ????
;         *F5 - ????
;      *F3 - Search
;       F4 - Input Address for Bookmark (no jump)
;       F5 - Jump to bookmark
;
;    ALPHA - View Registers (AF, HL, BC, DE, A, H, L, B, C, D, E, Flags C&Z)
;               Soon: IX, IY
;            (I did NOT test the flags, if they are returning incorrect info
;             please tell me and I'll fix it!)
;
;    GRAPH - View Output Screen
;       GRAPH - Copy Output Screen To Graph Screen
;
;    *STAT - Enter filename, gives various information on that file (no jump)
;    *PRGM - Enter filename, recalculate checksum (no jump)
;
;     *LOG - Browse VAT filenames
;        *SIN - jump to current file's data
;        *COS - jump to current file's VAT info
;
;      SIN - Enter filename, jump to that file's data.
;      COS - Enter filename, jump to that file's VAT information
;
;       UP - Scroll Screen Up 8 Bytes
;       DN - Down 8 Bytes
;     MORE - Scroll Screen Up 1 page (80 bytes)
;      DEL - Scroll Screen Down 1 page (80 bytes)
;       LE - Scroll Down 256 Bytes
;       RT - Scroll Up 256 Bytes
;   CUSTOM - Scroll Down 4096 Bytes
;    CLEAR - Scroll Up 4096 Bytes
;
;        + - Increase Contrast
;        - - Decrease Contrast
;
;      2nd - Power Off
;
; * = Not Working Yet

#include "/85/lib/usgard.h"
#include "/85/lib/displib.h"
#include "/85/lib/usgdlib.h"

.org 0

.db     69

.dw     fRAMDOM

fRAMDOM:

        exx
        ex      AF, AF'
        push    hl
        ld      (&ishl), hl
        ld      (&isde), de
        ld      (&isbc), bc
        push    af
        pop     hl
        ld      (&isaf), hl
        pop     hl
        exx
        ex      AF, AF'

        ld      hl, VIDEO_MEM
        ld      de, &GraphSave
        ld      bc, 8 * 128
        ldir                                    ; fantastic!  ld (de), (hl)

        ld      a, 4
        out     (5), a                           ;graphics mode

        ld      a, 0
        LIB_CALL_(DISPLIB, D_SET)

        jr      DrawScreen

MainKeyTest:
        call    GET_KEY

        cp      K_CUSTOM
        jp      z, &SubLots

        cp      K_CLEAR
        jp      z, &AddLots

        cp      K_EXIT
        jp      z, &drawgraph

        cp      K_RIGHT
        jp      z, &AddMore

        cp      K_LEFT
        jp      z, &SubMore

        cp      K_DOWN
        jp      z, &AddEight

        cp      K_UP
        jp      z, &SubEight

        cp      K_MORE
        jp      z, &SubEighty

        cp      K_DEL
        jp      z, &AddEighty

        cp      K_F1
        jp      z, &JumpTo

        cp      K_F5
        jp      z, &JumpZero

        cp      K_SIN
        jp      z, &JumpToVar

        cp      K_COS
        jp      z, &JumpToVAT

        cp      K_F2
        jp      z, &Convert

        cp      K_F4
        jp      z, &JumpSet

        cp      K_GRAPH
        jp      z, &dodrawgraph

        cp      K_ALPHA
        jp      z, &viewregs

        cp      K_PLUS
        jp      z, &ContUp

        cp      K_MINUS
        jp      z, &ContDown

        cp      K_SECOND
        jp      z, &PowerOff

        jr      MainKeyTest


DrawScreen:
        call    CLEARLCD
        ld      bc, $0000
        ld      (CURSOR_X), bc
        ld      hl, (&TopAt)
        ld      b, 10
TotalLoop:
        push    bc
        LIB_CALL_(DISPLIB, D_HL_HEX)
        ld      a, (CURSOR_X)
        inc     a
        inc     a
        inc     a
        inc     a
        ld      (CURSOR_X), a
        push    hl
        ld      b, 8
DrawScreenLoop:
        ld      a, (hl)
        LIB_CALL_(DISPLIB, D_A_HEX)
        inc     hl
        djnz    DrawScreenLoop
        ld      a, (CURSOR_X)
        add     a, 4
        ld      (CURSOR_X), a

        pop     hl
        ld      b, 8
DrawScreenTwo:
        ld      a, (hl)
        cp      215
        call    nc, &changeone
        ld      (&Char), a
        push    hl
        push    bc
        ld      hl, &Char
        ld      b, 1
        call    D_LM_STR
        pop     bc
        pop     hl

        inc     hl

        djnz    DrawScreenTwo

        ld      a, 0
        ld      (CURSOR_X), a
        ld      a, (CURSOR_Y)
        add     a, 6
        ld      (CURSOR_Y), a
        pop     bc
        djnz    TotalLoop
        jp      &MainKeyTest

changeone:
        ld      a, 9    ; looks like a demented x
        ret

dodrawgraph:
        call    &drawgraph

ddgloop:
        call    GET_KEY
        cp      K_GRAPH
        jr      z, copygraph

        cp      0
        jp      nz, &DrawScreen

        jr      ddgloop

drawgraph:
        ld      de, VIDEO_MEM
        ld      hl, &GraphSave
        ld      bc, 8 * 128
        ldir
        ret

copygraph:
        ld      de, GRAPH_MEM
        ld      hl, &GraphSave
        ld      bc, 8 * 128
        ldir
        jp      &DrawScreen

AddEighty:
        ld      hl, (&TopAt)
        ld      de, 80
        add     hl, de
        ld      (&TopAt), hl
        jp      &DrawScreen

SubEighty:
        ld      hl, (&TopAt)
        ld      de, 80
        sbc     hl, de
        ld      (&TopAt), hl
        jp      &DrawScreen

AddMore:
        ld      hl, (&TopAt)
        ld      de, $100
        add     hl, de
        ld      (&TopAt), hl
        jp      &DrawScreen

SubMore:
        ld      hl, (&TopAt)
        ld      de, $100
        sbc     hl, de
        ld      (&TopAt), hl
        jp      &DrawScreen

AddLots:
        ld      hl, (&TopAt)
        ld      de, $1000
        add     hl, de
        ld      (&TopAt), hl
        jp      &DrawScreen

SubLots:
        ld      hl, (&TopAt)
        ld      de, $1000
        sbc     hl, de
        ld      (&TopAt), hl
        jp      &DrawScreen

AddEight:
        ld      hl, (&TopAt)
        ld      de, $0008
        add     hl, de
        ld      (&TopAt), hl
        jp      &DrawScreen

SubEight:
        ld      hl, (&TopAt)
        ld      de, $0008
        sbc     hl, de
        ld      (&TopAt), hl
        jp      &DrawScreen

inccursor:
        ld      hl, (CURSOR_X)
        ld      de, 5
        add     hl, de
        ld      (CURSOR_X), hl
        ret

PowerOff:
        call    OTH_SHUTDOWN
        jp      &DrawScreen

ContDown:
        ld      hl, CONTRAST
        ld      a, (hl)
	sub     1
        jp      c, &MainKeyTest
        ld      (hl), a
	out     (2), a
        jp      &MainKeyTest
ContUp:
        ld      hl, CONTRAST
        ld      a, (hl)
	cp      31
        jp      z, &MainKeyTest
        inc     (hl)
	ld      a, (hl)
	out     (2), a
        jp      &MainKeyTest

ViewRegs:
        call    CLEARLCD
        ld      bc, $0000
        ld      (CURSOR_X), bc
        ld      hl, &reghl
        call    D_ZM_STR
        ld      hl, (&ishl)
        LIB_CALL_(DISPLIB, D_HL_HEX)
        call    &inccursor
        ld      hl, &regde
        call    D_ZM_STR
        ld      hl, (&isde)
        LIB_CALL_(DISPLIB, D_HL_HEX)
        call    &inccursor
        ld      hl, &regbc
        call    D_ZM_STR
        ld      hl, (&isbc)
        LIB_CALL_(DISPLIB, D_HL_HEX)
        call    &inccursor
        ld      hl, &regaf
        call    D_ZM_STR
        ld      hl, (&isaf)
        LIB_CALL_(DISPLIB, D_HL_HEX)

        ld      bc, $0800
        ld      (CURSOR_X), bc
        ld      hl, &rega
        call    D_ZM_STR
        ld      hl, (&isaf)
        ld      a, h
        LIB_CALL_(DISPLIB, D_A_DEC)
        call    &inccursor
        ld      hl, &regb
        call    D_ZM_STR
        ld      hl, (&isbc)
        ld      a, h
        LIB_CALL_(DISPLIB, D_A_DEC)
        call    &inccursor
        ld      hl, &regc
        call    D_ZM_STR
        ld      a, c
        ld      hl, (&isbc)
        ld      a, l
        LIB_CALL_(DISPLIB, D_A_DEC)

        ld      bc, $1000
        ld      (CURSOR_X), bc

        ld      hl, &regd
        call    D_ZM_STR
        ld      hl, (&isde)
        ld      a, h
        LIB_CALL_(DISPLIB, D_A_DEC)
        call    &inccursor
        ld      hl, &rege
        call    D_ZM_STR
        ld      hl, (&isde)
        ld      a, l
        LIB_CALL_(DISPLIB, D_A_DEC)
        call    &inccursor
        ld      hl, &regh
        call    D_ZM_STR
        ld      hl, (&ishl)
        ld      a, h
        LIB_CALL_(DISPLIB, D_A_DEC)
        call    &inccursor
        ld      hl, &regl
        call    D_ZM_STR
        ld      hl, (&ishl)
        ld      a, l
        LIB_CALL_(DISPLIB, D_A_DEC)

        ld      hl, &regflags
        ld      bc, $1800
        ld      (CURSOR_X), bc
        call    D_ZM_STR

        ld      hl, (&isaf)
        push    hl
        pop     af

        jr      nz, NoZee

        ld      hl, &flagz
        call    D_ZM_STR

AfterZee:

        jr      nc, NoCee

        ld      hl, &flagc
        call    D_ZM_STR

AfterCee:

        call    OTH_PAUSE
        jp      &DrawScreen

NoZee:
        ld      hl, &flagno
        call    D_ZM_STR
        jr      AfterZee

NoCee:
        ld      hl, &flagno
        call    D_ZM_STR
        jr      AfterCee

JumpToVAT:
        call    CLEARLCD
        ld      hl, &GetVar
        ld      bc, $0000
        ld      (CURSOR_X), bc
        call    D_ZM_STR
        ld      ix, &JumpTmp
        ld      a, %00010000
        ld      bc, $0702
        ld      (CURSOR_ROW), bc
        ld      c, 8
        LIB_CALL_(USGDLIB,INPST)
        ld      hl, &JumpTmp
        call    VAR_GET
        jr      c, novarshow
        ld      (&TopAt), de
        jp      &DrawScreen

JumpToVar:
        call    CLEARLCD
        ld      hl, &GetVar
        ld      bc, $0000
        ld      (CURSOR_X), bc
        call    D_ZM_STR
        ld      ix, &JumpTmp
        ld      a, %00010000
        ld      bc, $0702
        ld      (CURSOR_ROW), bc
        ld      c, 8
        LIB_CALL_(USGDLIB,INPST)
        ld      hl, &JumpTmp
        call    VAR_GET
        jr      c, novarshow
        ld      (&TopAt), hl
        jp      &DrawScreen
novarshow:
        ld      hl, &novar
        ld      bc, $0004
        ld      (CURSOR_ROW), bc
        call    D_ZT_STR
        call    OTH_PAUSE
        jp      &DrawScreen

Convert:
        call    CLEARLCD
        ld      hl, &CN
        ld      bc, $0000
        ld      (CURSOR_X), bc
        call    D_ZM_STR
        call    &GetAddr

        ld      a, 1
        LIB_CALL_(DISPLIB, D_SET)

        ld      bc, $0806
        ld      (CURSOR_ROW), bc

        LIB_CALL_(DISPLIB, D_HL_DEC)

        ld      hl, &CV
        ld      bc, $2000
        ld      (CURSOR_X), bc
        call    D_ZM_STR

        ld      a, 0
        LIB_CALL_(DISPLIB, D_SET)


        call    OTH_PAUSE
        jp      &DrawScreen


JumpSet:
        call    CLEARLCD
        ld      hl, &SetJump
        ld      bc, $0000
        ld      (CURSOR_X), bc
        call    D_ZM_STR
        call    &GetAddr
        ld      (&JumpButton), hl
        jp      &DrawScreen

JumpZero:
        ld      hl, &JumpButton
        call    LD_HL_MHL
        ld      (&TopAt), hl
        jp      &DrawScreen

JumpTo:
        call    CLEARLCD
        ld      hl, &JT
        ld      bc, $0000
        ld      (CURSOR_X), bc
        call    D_ZM_STR
        call    &GetAddr
        ld      (&TopAt), hl
        call    &drawscreen
        ret

GetAddr:
        ld      bc, $0802
        ld      (CURSOR_ROW), bc
        ld      hl, 0
        ld      (&JumpTmp), hl
        ld      a, 4
        ld      (&KeepLoop), a
GetAddrLoop:
        ld      a, (&KeepLoop)
        cp      0
        jr      z, EndLoop
        call    GET_KEY
        cp      K_0
        jp      z, &Zero
        cp      K_1      
        jp      z, &One
        cp      K_2
        jp      z, &Two
        cp      K_3
        jp      z, &Three
        cp      K_4
        jr      z, Four
        cp      K_5
        jr      z, Five
        cp      K_6
        jr      z, Six
        cp      K_7
        jr      z, Seven
        cp      K_8
        jr      z, Eight
        cp      K_9
        jr      z, Nine
        cp      K_LOG
        jr      z, AlphaA
        cp      K_SIN
        jr      z, AlphaB
        cp      K_COS
        jr      z, AlphaC
        cp      K_TAN
        jr      z, AlphaD
        cp      K_RAISE
        jr      z, AlphaE
        cp      K_LN
        jr      z, AlphaF
        jr      GetAddrLoop
EndLoop:
        ld      hl, (&JumpTmp)
        ret

AlphaF:
        ld      l, 15
        ld      a, 'F'
        jr      DoAdd

AlphaE:
        ld      l, 14
        ld      a, 'E'
        jr      DoAdd

AlphaD:
        ld      l, 13
        ld      a, 'D'
        jr      DoAdd

AlphaC:
        ld      l, 12
        ld      a, 'C'
        jr      DoAdd

AlphaB:
        ld      l, 11
        ld      a, 'B'
        jr      DoAdd

AlphaA:
        ld      l, 10
        ld      a, 'A'
        jr      DoAdd

Nine:
        ld      l, 9
        ld      a, '9'
        jr      DoAdd

Eight:
        ld      l, 8
        ld      a, '8'
        jr      DoAdd

Seven:
        ld      l, 7
        ld      a, '7'
        jr      DoAdd

Six:
        ld      l, 6
        ld      a, '6'
        jr      DoAdd

Five:
        ld      l, 5
        ld      a, '5'
        jr      DoAdd

Four:
        ld      l, 4
        ld      a, '4'
        jr      DoAdd

Three:
        ld      l, 3
        ld      a, '3'
        jr      DoAdd

Two:
        ld      l, 2
        ld      a, '2'
        jr      DoAdd

One:
        ld      l, 1
        ld      a, '1'
        jr      DoAdd

Zero:
        ld      l, 0
        ld      a, '0'
        jr      DoAdd

DoAdd:
        call    TX_CHARPUT
        ld      a, (&KeepLoop)
        dec     a
        ld      (&KeepLoop), a
        cp      0
        jr      z,AddOnes
        cp      1
        jr      z,AddTens
        cp      2
        jr      z,AddHundreds
        cp      3
        jr      z,AddThousands


AddThousands:
        ld      a, l
        sla     a
        sla     a
        sla     a
        sla     a
        ld      d, a
        ld      e, 0
        ld      hl, (&JumpTmp)
        add     hl, de
        ld      (&JumpTmp), hl
        jp      &GetAddrLoop


AddHundreds:
        ld      d, l
        ld      e, 0
        ld      hl, (&JumpTmp)
        add     hl, de
        ld      (&JumpTmp), hl
        jp      &GetAddrLoop


AddTens:
        ld      h, $10
        call    MUL_HL
        ld      d, h
        ld      e, l
        ld      hl, (&JumpTmp)
        add     hl, de
        ld      (&JumpTmp), hl
        jp      &GetAddrLoop


AddOnes:
        ld      d, 0
        ld      e, l
        ld      hl, (&JumpTmp)
        add     hl, de
        ld      (&JumpTmp), hl
        jp      &GetAddrLoop

JumpButton:     .dw 0
TopAt:  .dw     0
SetJump:.db     "Set F5 to Jump To:",0
GetVar: .db     "Variable Name to Jump To:",0
NoVar:  .db     "Variable NOT Found!",0
JT:     .db     "Jump To What Address:",0
CN:     .db     "Convert Hex to Decimal:",0
CV:     .db     "Decimal Value:",0
regh:   .db     "H: ",0
regl:   .db     "L: ",0
regd:   .db     "D: ",0
rege:   .db     "E: ",0
regb:   .db     "B: ",0
regc:   .db     "C: ",0
rega:   .db     "A: ",0
regf:   .db     "F: ",0
reghl:  .db     "HL: ",0
regde:  .db     "DE: ",0
regbc:  .db     "BC: ",0
regaf:  .db     "AF: ",0
regflags:.db    "Flags: ",0
flagz:  .db     "Z",0
flagno:.db     ".",0
flagc:  .db     "C",0
ishl:   .dw     0
isde:   .dw     0
isbc:   .dw     0
isaf:   .dw     0
JumpTmp:.dw     0
KeepLoop:.db    0
Char:   .db     0
AlsoNeeded:.db  0,0,0,0   ; must have at least 8 bytes!

GraphSave:
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw 0,0
.end
